use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize)]
pub struct Text {
    pub(crate) password: u64,
    pub(crate) text: String,
}

pub(crate) fn deserialize(data: String) -> Result<Text, serde_json::Error> {
    serde_json::from_str(Box::leak(data.into_boxed_str()))
}