use std::{fs::File, path::Path, io::Write, fs::write};
use std::string::ToString;
use text_io::read;
use rpassword::prompt_password;
use crate::data::Text;

use crate::hash;

pub static PATH: &str = "db.json";

pub fn new_file() -> File {
    let pass: String = prompt_password("Input the token: ").unwrap();
    print!("Input the text you want to display: ");
    let text_str: String = read!("{}\n");

    let path_obj = Path::new(&PATH);
    let text_obj = Text {
        password: hash::hash(pass),
        text: text_str,
    };
    let j = serde_json::to_string(&text_obj).unwrap();
    let mut file = match File::create(&path_obj) {
        Err(why) => panic!("couldn't create {}: {}", path_obj.display(), why),
        Ok(file) => file,
    };
    match file.write_all(j.to_string().as_bytes()) {
        Err(why) => panic!("couldn't write to {}: {}", path_obj.display(), why),
        Ok(file) => file,
    };
    return file;
}

pub fn write_file(data: Text) {
    let j = serde_json::to_string(&data).unwrap();
    write(&PATH, j).expect("Unable to write data;");
}

pub fn get_file() -> File {
    let path_obj = Path::new("db.json");
    let file: File = match File::open(&path_obj) {
        Err(_why) => new_file(),
        Ok(file) => file,
    };
    return file;
}